
#Compiler PbCC
#Dim      All

Function PbMain&
Dim f$
  f$ = Ltrim$( Rtrim$( Command$ ))
  Print
  If Len( f$ ) = 0 or Instr( f$, "/?" ) <> 0 Then
    Print "Usage : Pasm2c filename"
    Print
    Print "Reads   filename.eeprom ( or filename.binary )"
    Print "Creates filename_array.h"
  Else
    If Dir$( f$+".eeprom" ) <> "" Then
      Call Extractor( f$, ".eeprom" )
    Else
      If Dir$( f$+".binary" ) <> "" Then
        Call Extractor( f$, ".binary" )
      Else
        Print "Cannot find "+f$+".eeprom or "+f$+".binary"
      End If
    End If
  End If
End Function

Sub Extractor( ByVal f$, ByVal e$ )
Dim count&
Dim startPtr&
Dim endPtr&
Dim c$
Dim i&
Dim o$

  f$ = Dir$( f$+e$ )
  f$ = Left$( f$, Len( f$ )-Len( e$ ) )

  Open f$+"_array.h" For Output As #2
  Print#2, ""
  Print#2, "long "+lcase$( f$ )+"_array[] ="
  Print#2, "{"

  Open f$+e$ For Binary As #1
  startPtr& = &h0018
  Seek#1, &h000C+1
  Get$#1, 1, c$ : endPtr& = asc( c$ )
  Get$#1, 1, c$ : endPtr& = endPtr& + ( asc( c$ ) * 256 )

  count& = ( endPtr& - startPtr& ) \ 4

  Seek#1, startPtr&+1
  For i&=1 To count&
    Get$#1, 1, c$ : o$ = Hex$( Asc(c$), 2 )
    Get$#1, 1, c$ : o$ = Hex$( Asc(c$), 2 ) + o$
    Get$#1, 1, c$ : o$ = Hex$( Asc(c$), 2 ) + o$
    Get$#1, 1, c$ : o$ = Hex$( Asc(c$), 2 ) + o$
    If i& < count& Then
      Print#2, "  0x"+o$+","
    Else
      Print#2, "  0x"+o$
    End If
  Next

  Print#2, "};"
  Print#2, ""
  Close#2
  Close#1

  Print "Created "+f$+"_array.h ( "+Str$(count&)+" instructions )"

End Sub

